unit newdockedform;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, IDEWindowIntf, MenuIntf, IDECommands, Forms, LCLType,
  Dialogs, Graphics;

resourcestring
  mnuShowDockedForm = 'Show MyDockedForm';

type

  { TMyNewDockedForm }

  TMyNewDockedForm = class (TCustomForm)
  public
   constructor CreateNew(AOwner: TComponent; Num: Integer = 0); override;
   destructor  Destroy; override;
  end;
procedure Register;


var MyNewDockedForm    : TMyNewDockedForm = nil;
    Cmd                : TIDEMenuCommand  = nil;
    CmdMessageComposer : TIDECommand;

implementation

procedure CreateMyNewDockedForm(Sender: TObject; aFormName: string; var AForm: TCustomForm; DoDisableAutoSizing: boolean);
begin
 if CompareText(aFormName,'MyNewDockedForm')<>0 then exit;

 IDEWindowCreators.CreateForm(MyNewDockedForm,TMyNewDockedForm,DoDisableAutosizing,Application);

 AForm:=MyNewDockedForm;
end;

procedure OnCmdClick(Sender: TObject);
begin
 IDEWindowCreators.ShowForm(MyNewDockedForm.Name,true);
end;

procedure Register;
var Key      : TIDEShortCut;
    Cat      : TIDECommandCategory;
    CmdMyTool: TIDECommand;
begin
  {$R image.res}
  MyNewDockedForm := TMyNewDockedForm.CreateNew(Application,0);

  IDEWindowCreators.Add('MyNewDockedForm',@CreateMyNewDockedForm,nil,'100','50%','+300','+20%');

  //Erzeugt den Menüeintrag mit Shortcut:
  Key := IDEShortCut(VK_M,[ssCtrl],VK_UNKNOWN,[]);
  Cat := IDECommandList.FindIDECommand(ecFind).Category;
  CmdMyTool := RegisterIDECommand(Cat,mnuShowDockedForm,mnuShowDockedForm, Key, nil,@OnCmdClick);
  Cmd := RegisterIDEMenuCommand(itmCustomTools,mnuShowDockedForm,mnuShowDockedForm, nil, nil, CmdMyTool,'Add_01_16');

  //Ohne Shortcut
  //RegisterIDEMenuCommand(itmCustomTools, mnuShowDockedForm,mnuShowDockedForm,nil,@OnCmdClick,nil);

end;

{ TMyNewDockedForm }
constructor TMyNewDockedForm.CreateNew(AOwner: TComponent; Num: Integer);
begin
  inherited CreateNew(AOwner, Num);
  Name := 'MyNewDockedForm';
  Caption := 'My Docked Window';
  SetBounds(100,100,500,800);
  Color := clWindow;
end;

destructor TMyNewDockedForm.Destroy;
begin

  inherited Destroy;
end;

end.

